####! ruby -Ku
##made by tak2hata  http://onigiriburning.so.land.to/
##since 2010/9/10
##Create object from DXF.
##Readabl Entity classes
	##ATTRIB
	##ARC
	##CIRCLE
	##ELLIPSE
	##INSERT
	##LINE
	##LWPOLYLINE(with arc)
	##POLYLINE
	##MTEXT
	##TEXT
	##(SPLINE:polyline from control points)
##text code:UTF-8
##v0.9 :2011.01.28 Change importing Text type to 3d text.
##v1.0 :2011.02.05 First Fix version.
##v1.01 :2011.02.09 Add Ellipse.
##v1.02 :2011.02.10 support arc in polyline.
##v1.1  :2011.02.12 SPLINE(as Polyline from control points)
##v2.0  :2012.09.01 Improves.
##v2.1  :2012.09.05 Improves.
##v2.5  :2013.01.27 Improves.
##v2.6  :2013.02.19 improve for 000additionalpluginfolders.
##v2.7  :2013.02.21 Improve about 3D Text.
##v2.8  :2013.02.22 Add Control Circle(Arc) Division.
##v2.9  :2013.02.24 Add Language select.
##v3.0  :2013.03.03 Add new function "Create Faces from two edges".
##v3.1  :2013.03.07 Small bug fix.
##v3.5  :2013.04.13
##v3.6  :2013.04.29 File path including Special character freely.without NKF.
##v3.7  :2013.05.11 Add "Thomthom'3d text editor' attribute to 3D text.
##v4.0  :2013.08.16 Fix text encode problem by using Win32OLE.
##v4.0.1:2013.08.18 BugFIX.Test Varius WhiteSpace in text.
##This script needs win32ole.so
##license code:(http://creativecommons.org/licenses/by/3.0/)
##日本語対応

require 'sketchup.rb'
require 't2h_2d_dxf_import/win32ole'

module TAK2HATA::T2H_2D_DXF_IMPORT
class DxfTextImport
	def initialize()
		if RUBY_PLATFORM[/darwin/]
			@is_mac = true
			@fso = nil
		else
			@is_mac = false
			WIN32OLE.codepage = WIN32OLE::CP_UTF8
			@fso = WIN32OLE.new('Scripting.FileSystemObject')
		end
	end
	def fso_dirname( filename )
		if @is_mac == true
			return File.dirname( filename )
		else
			return @fso.GetParentFolderName( filename )
		end
	end
	def fso_basename( filename , extname)
		if @is_mac == true
			return File.basename( filename )
		else
			return @fso.GetBaseName( filename )
		end
	end
	def fso_expand_path( filename )
		if @is_mac == true
			return File.expand_path( filename )
		else
			return @fso.GetAbsolutePathName( filename )
		end
	end
	def fso_file_exists( filename )
		if @is_mac == true
			return FileTest.exists?( filename )
		else
			return @fso.FileExists( filename )
		end
	end
	def fso_file_join( fname1 , fname2 = "", fname3 = "" , fname4 = "" , fname5 = "" , fname6 = "" , fname7 = "" )
		fnlist = []
		fnlist.push fname1 if fname1 != ""
		fnlist.push fname2 if fname2 != ""
		fnlist.push fname3 if fname3 != ""
		fnlist.push fname4 if fname4 != ""
		fnlist.push fname5 if fname5 != ""
		fnlist.push fname6 if fname6 != ""
		fnlist.push fname7 if fname7 != ""
		return fnlist.join(File::SEPARATOR)
	end
	def select_langfile
		#lang_dir = File.join( File.dirname( File.expand_path(__FILE__) ), "languages" )
		lang_dir = File.join( fso_dirname( fso_expand_path(__FILE__) ), "languages" )
		lang_path=UI.openpanel(langconv("Select Language File"),lang_dir,"*.txt")
		return false if lang_path == "" or lang_path == false
		return false if not lang_path
		lang_path = fso_expand_path( lang_path )
		if not fso_file_exists( lang_path )
			UI.messagebox( "File is not exists!(or The file-path includes special characters)::#{lang_path}" )
		end
		Sketchup.write_default( "T2H_2D_DXF_IMPORT", "lang_path2", lang_path.unpack("H*") )
		load_langtxt( )
		UI.messagebox langconv("The language convert will be effective after Sketchup restarted")
	end
	def load_langtxt( )
		lang_path =  File.join( fso_dirname( fso_expand_path(__FILE__) ), "languages" , "lang.txt")
		lang_path_arr = Sketchup.read_default( "T2H_2D_DXF_IMPORT", "lang_path2", lang_path )
		begin
			lang_path = lang_path_arr.pack("H*")
		rescue
			lang_path = ""
		end
		return nil if not lang_path
		lang_path = fso_expand_path( lang_path )
		return nil if not fso_file_exists( lang_path )
		@langhash = Hash.new
		lang_file=File.new(lang_path,"r")##read mode
		lang_file.each{|line|
			if line != "" and line[0] != "#" and line["\|"]
				splt = ( line.chomp ).split("\|")
				if splt[0] != "" and splt[1] != ""
					@langhash[splt[0]] = splt[1]
				end
			end
		}
		lang_file.close
	end
	def langconv( tstr )
		ret = ""
		load_langtxt if @langhash == nil
		return tstr if @langhash == nil
		if @langhash.size > 0
			ret = @langhash[tstr] if @langhash[tstr] != nil
			ret = tstr if ret == ""
		else
			ret = tstr
		end
		return ret
	end
	def import_trihedra_drawings
		#option_initialize()
	    model = Sketchup.active_model
	    dxf_wdlg = UI::WebDialog.new(langconv("DXF Three-View-Drawings"), true, "DXF Three-View-Drawings", 440, 250, 150, 150, true)
		htmfile = File.join( fso_dirname( fso_expand_path(__FILE__) ), "dxfimport_dialog.html" )
		#htmfile = Sketchup.find_support_file "dxfimport_dialog.html", "Plugins/dxftext_import/"
	    dxf_wdlg.set_file(htmfile)
	    dxf_wdlg.add_action_callback("selectfile"){|d,p|
			open_filename = UI.openpanel langconv("Select DXF file"), "", "*.dxf"
			return if open_filename == nil
			open_filename.gsub!(/\\/,'/')
			cmd = "document.getElementById('#{p}').value='#{open_filename}';"
			dxf_wdlg.execute_script( cmd )
			search_other_file( open_filename ,dxf_wdlg) if p == "plan_file"
  	    }
		dxf_wdlg.add_action_callback("dxfimport"){|d,p|
			compname = dxf_wdlg.get_element_value("comp_name")
			planfile = dxf_wdlg.get_element_value("plan_file")
			frontfile = dxf_wdlg.get_element_value("front_file")
			rsidefile = dxf_wdlg.get_element_value("r_side_file")
			lsidefile = dxf_wdlg.get_element_value("l_side_file")
			modelfile = dxf_wdlg.get_element_value("model_file")
			dxf_wdlg.close
			rot = 0
			rot = -90.degrees if p == "1"
			start_trihedral_import(compname ,planfile,frontfile,rsidefile,lsidefile,modelfile,rot)
		}
	    dxf_wdlg.show_modal{}
	end
	def search_other_file(open_filename,dxf_wdlg)
		filename = check_file_path(open_filename)
		return if filename == nil

		bname = fso_basename( filename , ".dxf" )
		pdir = fso_dirname( filename )
		
		aname = bname.split("_")[0]
		cmd = "document.getElementById('comp_name').value='#{aname}';"
		dxf_wdlg.execute_script( cmd )
		
		counter = ["2","3","4"]
		if bname[-1,1] == "1"
		elsif bname[-1,1] == "A"
			counter = ["B","C","D"]
		end
		bname = bname[0,bname.length-1]
	
		cname = File.join( pdir , "#{bname + counter[0]}.dxf" )
		if fso_file_exists( cname )
			cmd = "document.getElementById('front_file').value='" + cname.gsub(/\\/,'/') + "';"
			dxf_wdlg.execute_script( cmd )
		end
		cname = File.join( pdir , "#{bname + counter[1]}.dxf" )
		if fso_file_exists( cname )
			cmd = "document.getElementById('r_side_file').value='" + cname.gsub(/\\/,'/') + "';"
			dxf_wdlg.execute_script( cmd )
		end
		cname = File.join( pdir , "#{bname + counter[2]}.dxf" )
		if fso_file_exists( cname )
			cmd = "document.getElementById('l_side_file').value='" + cname.gsub(/\\/,'/') + "';"
			dxf_wdlg.execute_script( cmd )
		end
	end
	def start_trihedral_import( compname = "",planfile = "",frontfile = "",rsidefile = "",lsidefile = "",modelfile = "" ,rot = 0 )
		return if compname == "" or planfile == ""
		dxfpath = check_file_path(planfile)
		return if dxfpath == nil
		model = Sketchup.active_model
		defs = model.definitions
		layers = model.layers
		layers.add("DXF_PLAN_VIEW") if not layers["DXF_PLAN_VIEW"]
		layers.add("DXF_RSIDE_VIEW") if not layers["DXF_RSIDE_VIEW"]
		layers.add("DXF_LSIDE_VIEW") if not layers["DXF_LSIDE_VIEW"]
		layers.add("DXF_FRONT_VIEW") if not layers["DXF_FRONT_VIEW"]
		return if not import_setting()
		
		model.start_operation "DXF trihedral Importer",true
		starttime = Time.now.to_f
		#planfile
			readdxf( dxfpath , @charset )
			planview = defs.add("[PLANVIEW]_#{compname}")
			tg = planview.entities.add_group
			tg.name = "DXF-#{fso_basename(dxfpath,".dxf")}"
			tg.entities.add_cpoint([0,0,0])
			tgadd_entities tg
			tg.layer = "DXF_PLAN_VIEW"
		##
		#frontfile
			dxfpath = check_file_path(frontfile)
			if dxfpath != nil
				readdxf( dxfpath , @charset )
				frontview = defs.add("[FRONTVIEW]_#{compname}")
				tg = frontview.entities.add_group
				tg.name = "DXF-#{fso_basename(dxfpath,".dxf")}"
				tg.entities.add_cpoint([0,0,0])
				tgadd_entities tg
				tg.layer = "DXF_FRONT_VIEW"
			end
		##
		#RightSidefile
			dxfpath = check_file_path(rsidefile)
			if dxfpath != nil
				readdxf( dxfpath , @charset )
				rsideview = defs.add("[RSIDEVIEW]_#{compname}")
				tg = rsideview.entities.add_group
				tg.name = "DXF-#{fso_basename(dxfpath,".dxf")}"
				tg.entities.add_cpoint([0,0,0])
				tgadd_entities tg
				tg.layer = "DXF_RSIDE_VIEW"
			end
		##
		#LeftSidefile
			dxfpath = check_file_path(lsidefile)
			if dxfpath != nil
				readdxf( dxfpath , @charset )
				lsideview = defs.add("[LSIDEVIEW]_#{compname}")
				tg = lsideview.entities.add_group
				tg.name = "DXF-#{fso_basename(dxfpath,".dxf")}"
				tg.entities.add_cpoint([0,0,0])
				tgadd_entities tg
				tg.layer = "DXF_LSIDE_VIEW"
			end
		##
		maincomp = defs.add( compname )
		tr = Geom::Transformation.rotation( [0,0,0] , Geom::Vector3d.new( 0,0,1) , rot )
		maincomp.entities.add_instance( planview , tr )
		tr = Geom::Transformation.rotation( [0,0,0] , Geom::Vector3d.new( 0,0,1) , -90.degrees ) * Geom::Transformation.rotation( [0,0,0] , Geom::Vector3d.new( 1,0,0) , 90.degrees )
		maincomp.entities.add_instance( lsideview , tr ) if lsideview
		tr = Geom::Transformation.rotation( [0,0,0] , Geom::Vector3d.new( 0,0,1) , 90.degrees ) * Geom::Transformation.rotation( [0,0,0] , Geom::Vector3d.new( 1,0,0) , 90.degrees )
		maincomp.entities.add_instance( rsideview , tr ) if rsideview
		tr = Geom::Transformation.rotation( [0,0,0] , Geom::Vector3d.new( 1,0,0) , 90.degrees )
		maincomp.entities.add_instance( frontview , tr ) if frontview
		
		wastetime = Time.now.to_f - starttime
		Sketchup.set_status_text "Finished! time is #{wastetime} sec"
		model.commit_operation
		model.place_component maincomp ,true
		#@fso = nil
	end
	def startimport()
		#option_initialize()
		model = Sketchup.active_model
		return if not import_setting()
		dxfpath = dxffileselect
		
		dxfpath = check_file_path(dxfpath)
		return if dxfpath == nil
		model.start_operation langconv("DXF TEXT Importer"),true
		starttime = Time.now.to_f
		#DXF 読み込みスタート
		readdxf( dxfpath , @charset )# if fso_file_exists( dxfpath)
		allcount = @textlist.size + @linelist.size + @plinelist.size + @circlelist.size
		count = 0
		tg = model.entities.add_group
		tg.name = "DXF-#{fso_basename(dxfpath,".dxf")}"
		tgadd_entities tg
		model.commit_operation
		wastetime = Time.now.to_f - starttime
		msg = "Finished! time is #{wastetime} sec"
		msg << "Errors:\n" + @errlist.map{|p1,p2| "#{p1}:#{p2}" }.join("\n") if @errlist and @errlist != []
		
		UI.messagebox msg
		Sketchup.send_action("viewZoomExtents:")
		
	end
	def check_file_path(dxfpath)
		return nil if dxfpath == false or dxfpath == ""
		return nil if dxfpath == nil
		return dxfpath
		
		
		#これより下は使わない
		dxfpath = char_conv(dxfpath)
		
		#if $kconvloaded == true
			#UTF-8 japanese to Shift-JIS(ANSI based)
		#	dxfpath = NKF.nkf('-Wsx', dxfpath) #Kconv.tosjis(dxfpath)
		#end
		#@textlist,@linelist,@plinelist,@circlelist = 
		if fso_file_exists( dxfpath )
			return dxfpath
		else
			#UI.messagebox "This script can not read from filepath include japanese."
			return nil
		end
	end
	def import_setting()
		@two_d = true #2D only in this version
		@inch = false
		@drscale = 1.0 / 25.4#(to_mm)
		@chkText = langconv("3D TEXT")
		@circle2comp = 1001.mm
		@tsc = 1.0
		@with_cline = false
		@with_face = false
		@divtole = 2000.mm
		dxfunits = langconv("Milimeter")
		chkText = @chkText
		tsc = @tsc.to_s
		with_cline = langconv("No")
		with_face = langconv("No")
		circle2comp = @circle2comp.to_s
		divtole = @divtole.to_s
		charset="Auto"#["Auto","OS_Default","UTF-8"]
		#get_font_list()#list is get in @get_font_list
		#cfont = "ＭＳ Ｐゴシック"
		
		ssdf = Sketchup.read_default("T2H_2D_DXF_IMPORT", "settings")
		defaults = [ chkText,dxfunits,with_cline,with_face,tsc,divtole,circle2comp ]#,cfont ]
		#[ chkText,dxfunits,with_cline,tsc,divtole,circle2comp ]
		#[ chkText,dxfunits,with_cline,tsc,circle2comp ]
		texttype_list = ["No","3D TEXT","2D TEXT","3D TEXT(NO EDGES)"]
		unitstype_list = ["Inch","Feet","Milimeter","Centimeter","Meter"]
		yesno_list = ["Yes","No"]
		charsetlist = ["Auto","OS_Default","UTF-8"]
		#cfont2 = Sketchup.read_default("T2H_2D_DXF_IMPORT", "font_settings" )
		#begin
		#	cfont = cfont2.pack("H*")
		#rescue	
		#	cfont = "ＭＳ Ｐゴシック"
		#end
		#cfont = @get_font_list[0] if not @get_font_list.include?(cfont)
		if not ssdf
			#ssdf = [ @chkText,dxfunits,yn_cline,@tsc,@circle2comp ].inspect.gsub( 34.chr , "'")
		else
			testarray = eval(ssdf)
			if testarray.size == 8
				chkText,dxfunits,with_cline,with_face,tsc,divtole,circle2comp,charset = testarray
				if charsetlist.index(charset) == nil
					charset = "Auto"
				end
			elsif testarray.size == 7
				chkText,dxfunits,with_cline,with_face,tsc,divtole,circle2comp = testarray
			elsif testarray.size == 6
				chkText,dxfunits,with_cline,tsc,divtole,circle2comp = testarray
			else
				chkText,dxfunits,with_cline,tsc,circle2comp = testarray
			end
			chkText = langconv(chkText)
			dxfunits = langconv(dxfunits)
			with_cline = langconv(with_cline)
			with_face = langconv(with_face)
			i = texttype_list.map{|txt| langconv(txt) }.index( chkText )
			chkText = langconv("3D TEXT(NO EDGES)") if not i
			i = unitstype_list.map{|txt| langconv(txt) }.index( dxfunits )
			dxfunits = langconv("Milimeter") if not i
			i = yesno_list.map{|txt| langconv(txt) }.index( with_cline )
			with_cline = langconv("No") if not i
			i = yesno_list.map{|txt| langconv(txt) }.index( with_face )
			with_face = langconv("No") if not i
		end
		
		defaults = [ chkText,dxfunits,with_cline,with_face,tsc,divtole,circle2comp,charset]#,cfont ]
		#Import Setting DialogBOX
		prompts = [ langconv("Import Text ,too?") , langconv("Dxf Units?") , langconv("Open shapes to Cline"), langconv("Closed shapes to Face") , langconv("Text Scaling:") , langconv("Radius for 24 division:") , langconv("Change to Component by Radius:") ,langconv("Select CharSet")]
		#defaults = [ @chkText , "Milimeter", "No" , @tsc.to_s , @circle2comp.to_s ]
		list = []
		list.push texttype_list.map{|txt| langconv(txt) }.join("|")
		list.push unitstype_list.map{|txt| langconv(txt) }.join("|")
		list.push yesno_list.map{|txt| langconv(txt) }.join("|")
		list.push yesno_list.map{|txt| langconv(txt) }.join("|")
		list.push "0.5|1.0|2.0|4.0"
		list.push ""
		list.push ""
		list.push charsetlist.join("|")
		#list.push @get_font_list.join("|")
		result = UI.inputbox( prompts, defaults, list , "2D DXF Import Option" )
		return nil if result == nil || result == false
		chkText,dxfunits,with_cline,with_face,tsc,divtole,circle2comp,charset = result  ##,cfont
		
		i = texttype_list.map{|txt| langconv(txt) }.index( chkText )
		chkText = texttype_list[ i ] if i
		@chkText = chkText

		i = unitstype_list.map{|txt| langconv(txt) }.index( dxfunits )
		dxfunits = unitstype_list[ i ] if i
		#if dxfunits == langconv("Inch")
		if dxfunits == "Inch"
			@inch = true
			@drscale = 1.0
		elsif dxfunits == "Feet"
			@drscale = 12.0
		elsif dxfunits == "Milimeter"
			@drscale = 1.0 / 25.40
		elsif dxfunits == "Centimeter"
			@drscale = 10.0 / 25.40
		elsif dxfunits == "Meter"
			@drscale = 1000.0 / 25.40
		end
		i = yesno_list.map{|txt| langconv(txt) }.index( with_cline )
		with_cline = yesno_list[ i ] if i
		i = yesno_list.map{|txt| langconv(txt) }.index( with_face )
		with_face = yesno_list[ i ] if i

		@with_cline = true if with_cline == "Yes"
		@with_face = true if with_face == "Yes"
		@tsc = tsc.to_f if tsc != ""
		@divtole = divtole.to_l if divtole != ""
		@circle2comp = circle2comp.to_l if circle2comp != ""
		@divtole = 1.mm if @divtole == 0.0
		@circle2comp = 1.mm if @circle2comp == 0.0
		@charset = charset
		#@cfont = cfont.to_s
		divtole = @divtole.to_s
		circle2comp = @circle2comp.to_s
		Sketchup.write_default("T2H_2D_DXF_IMPORT", "settings" , [ chkText,dxfunits,with_cline,with_face,tsc,divtole,circle2comp,charset ].inspect.gsub( 34.chr , "'"))
		
		#Sketchup.write_default("T2H_2D_DXF_IMPORT", "font_settings" , cfont.unpack("H*"))
	end
	def dxffileselect
		dxf_path=UI.openpanel(langconv("Select DXF file|"),"","*.dxf")
		return false if dxf_path == "" or dxf_path == false
		return dxf_path
		if fso_file_exists(dxf_path)
			#dxf_path.gsub!(/\\/,"/")
			return dxf_path
		else
			return false
		end
	end

	def readdxf( dxfpath , charset = "Auto" )
		#enc::-2システムデフォルト,-1UTF_8,0-ASCII
		#preread_text( dxfpath )
		
		init_arrays
		@errlist = []
		dxffile = []
		if @is_mac
			ts = File.open( dxfpath ,"r")
			tbuff = ts.read
			ts.close
			dxffile = tbuff.split("\n")
			tbuff = nil
			objTextStream.close
		else
			if charset == "UTF-8"
				adst=WIN32OLE.new("ADODB.Stream")
				adst.Charset = "UTF-8"
				adst.Open
				adst.LoadFromFile(dxfpath)
				until( adst.EOS == true )
					#次の行を読み取る
					dxffile.push adst.ReadText(-2)
				end
				
				#tbuff = adst.ReadText
				#dxffile = tbuff.split("\n")
				#tbuff = nil
				adst.close
				adst = nil
			else
				objTextStream = @fso.opentextfile(dxfpath, 1, false, -2 )
				tbuff = objTextStream.readall
				dxffile = tbuff.split("\n")
				tbuff = nil
				objTextStream.close
			end
		end
		#dxffile = tbuff.split("\n")
		
		#tbuff = nil
		
		#p dxffile.size
		#dxffile = File.open( dxfpath ,"r")
		
		init_att
		Sketchup.set_status_text "Search ENTITIES SECTION"
		@entsec = false
		#BLOCKSもしくはENTITIESまで読み飛ばす
		#$DWGCODEPAGEがあったら文字コードを判定しなおす
		#p dxffile.size
		#p dxffile[0,30]
		while line1 = dxffile.shift
		#while line1 = dxffile.gets
			line2 = dxffile.shift
			#line2 = dxffile.gets
			line1.chomp!
			line1.strip!
			line2.chomp!
			line2.strip!
			line1 = "#{line1}"
			line2 = "#{line2}"
			#line1.chomp!.strip!
			#line2 = dxffile.gets.chomp.strip
			if line1 == "2" and line2.upcase == "BLOCKS"
				break
			elsif line1 == "2" and line2.upcase == "ENTITIES"
				@entsec = true
				break
			elsif line1 == "9" and line2.upcase == "$DWGCODEPAGE"
				line1 = dxffile.shift
				line2 = dxffile.shift
				line1.chomp!
				line1.strip!
				line2.chomp!
				line2.strip!
				if @is_mac == false and charset == "Auto"
					if line2 == "UTF_8"
						dxffile = []
						readdxf( dxfpath , "UTF-8" )
						return
					end
				end
			end
			#UI.messagebox line1 + "\n" + line2 if lc < 20
		end

		#p dxffile.size
		#dxffile.each{|line_p|
		Sketchup.set_status_text "Search TEXT"
		init_att
		@startblock = false
		@startblockdef = false
		@endblk = false
		@type = false
		#gettingblocks
		opt = [0,0,0]
		blockname = ""
		@block_definitions = []
		block_stocker = []
		chkfirst = true
		if @entsec == false#まだBLOCKSセクションのとき
			while line1 = dxffile.shift
			#while line1 = dxffile.gets
				line2 = dxffile.shift
				#line2 = dxffile.gets
				
				line1.chomp!
				line1.strip!
				line2.chomp!
				line2.strip!
				line1 = "#{line1}"
				line2 = "#{line2}"
				#line1.chomp!.strip!
				#line2 = dxffile.gets.chomp.strip
				#２行づつ読む
				if @startblockdef == true
					if getDxfEntities( line1 , line2 ) == false
						if @endblk == true
							#component definition定義の開始
							@startblockdef = false
							#UI.messagebox blockname
							if blockname[/^[\*\#\$\!]/] || blockname[/[\*\/\"\'\!]/] || blockname == ""
							#if blockname[/\$*\**Paper_Space.*/] || blockname[/\$*\**Model_Space.*/] || blockname == ""
							elsif @textlist.size + @linelist.size + @plinelist.size + @circlelist.size + @arclist.size + @blocklist.size > 0
								if @type == true
									addnil_arrays
									#20130127
									defin_block( blockname , opt )
									#20130127-
									@type = false
								end
							end
							init_arrays
							blockname = ""
							@startblockdef = false
							@endblk = false
							@ly = []
							chkfirst = true
							opt = [0,0,0]
						elsif @startblock == true
							if line1 == "0"
								#UI.messagebox "#{@name },text#{ @textlist.size } ,line#{ @linelist.size } , pline#{ @plinelist.size } , circle#{ @circlelist.size },arc#{ @arclist.size}\n" + @lylist.join("\n")
								if @x.size > 0
									xyzcheck
									if @name[/^[\*\#\$\!]/] || @name[/[\*\/\"\'\!]/] || @name == ""
									else
										@blocklist.push [@name.clone , Geom::Point3d.new( @pts[0].x.to_f , @pts[0].y.to_f ,  @pts[0].z.to_f ),@ly.clone,@scale.to_f,@stang.to_f]
										Sketchup.set_status_text "Find:BLOCK"
									end
								end
								init_att
								@name = ""
								@startblock = false
								checkSec line1,line2
							else
								get_att line1,line2
							end

						elsif line1 == "0"
							if chkfirst == true
								xyzcheck
								if @pts.size > 0
									opt = Geom::Point3d.new( @pts[0].x.to_f, @pts[0].y.to_f , 0 )
								end
								chkfirst = false
								
							end
							init_att
							checkSec line1,line2
						elsif line1 == "2"
							blockname = line2 if blockname == ""
						else
							get_att line1,line2
						end
					end
				elsif line1 == "0"
					@type = false
					checkSec line1,line2
				end
				break if line1 == "0" and line2 == "ENDSEC"#blockセクション終了
			end
		end#if @entsec
		#read entities section
		##update_all_definitions()

		init_arrays
		while line1 = dxffile.shift
		#while line1 = dxffile.gets
			line2 = dxffile.shift
			#line2 = dxffile.gets
			line1.chomp!
			line1.strip!
			line2.chomp!
			line2.strip!
			line1 = "#{line1}"
			line2 = "#{line2}"
			#２行づつよむ
			if getDxfEntities( line1 , line2 ) == false
				if @startblock == true
					if line1 == "0"
						#UI.messagebox "#{@name },text#{ @textlist.size } ,line#{ @linelist.size } , pline#{ @plinelist.size } , circle#{ @circlelist.size },arc#{ @arclist.size}\n" + @lylist.join("\n")
						if @x.size > 0
							xyzcheck
							if @name[/^[\*\#\$\!]/] || @name[/[\*\/\"\'\!]/] || @name == ""
							else
								@blocklist.push [@name.clone , Geom::Point3d.new( @pts[0].x.to_f , @pts[0].y.to_f ,  @pts[0].z.to_f ),@ly.clone,@scale.to_f,@stang.to_f]
								Sketchup.set_status_text "Find:BLOCK"
							end
						end
						init_att
						@name = ""
						@startblock = false
						checkSec line1,line2
					else
						get_att line1,line2
					end
				elsif line1 == "0"
					checkSec line1,line2
				end
				break if line1 == "0" and line2.upcase == "ENDSEC"
			end
		end
		#dxffile.close
		Sketchup.set_status_text "End of DXF"
		addnil_arrays
		return true
	end
	def getDxfEntities( line1 , line2 )
		if @starttext == true or @startmtext == true
			if line1 == "0"
				if @txt != ""
					@textlist.push [@txt, Geom::Point3d.new( @x[0].to_f , @y[0].to_f , 0 ),@ly,@radius,@stang,@justyf] if @txt != ""
					Sketchup.set_status_text "Find:" + @txt
				end
				init_att
				checkSec line1,line2
			else
				get_att line1,line2
			end
		elsif @startarc == true
			if line1 == "0"
				xyzcheck
				@arclist.push [Geom::Point3d.new( @pts[0].x , @pts[0].y ,  @pts[0].z ),@radius,@stang,@enang,@ly]
				Sketchup.set_status_text "Find:ARC"
				init_att
				checkSec line1,line2
			else
				get_att line1,line2
			end
		elsif @startcircle == true
			if line1 == "0"
				xyzcheck
				@circlelist.push [Geom::Point3d.new( @pts[0].x , @pts[0].y ,  @pts[0].z ),@radius,@ly]
				Sketchup.set_status_text "Find:CIRCLE"
				init_att
				checkSec line1,line2
			else
				get_att line1,line2
			end
		elsif @startelli == true
			if line1 == "0"
				xyzcheck
				cpt = Geom::Point3d.new( @pts[0].x , @pts[0].y ,  @pts[0].z )
				vec_e = Geom::Point3d.new( @pts[1].x , @pts[1].y ,  @pts[1].z )
				@ellilist.push [ cpt , vec_e , @ratio , @stang , @enang , @ly ]
				Sketchup.set_status_text "Find:ELLIPSE"
				init_att
				checkSec line1,line2
			else
				get_att line1,line2
			end
		elsif @startline == true
			if line1 == "0"
				if @x.size == 2 and @y.size == 2
					xyzcheck
					@linelist.push [@pts,@ly]
					Sketchup.set_status_text "Find:Line"
				end
				init_att
				checkSec line1,line2
			else
				get_att line1,line2
			end
		elsif @startpline == true
			if line1 == "0"
				if @x.size > 1
					xyzcheck
					@bg.push @bulge
					#UI.messagebox "#{@pts.size},#{@bg.size}"
					@plinelist.push [@pts,@ly,@bg,@close,@startspline]
					Sketchup.set_status_text "Find:LWPOLYLine"
				end
				init_att
				checkSec line1,line2
			else
				get_att line1,line2
			end
		elsif @starthwpline == true
			if line1 == "0" and line2.upcase == "SEQEND"
				if @x.size > 1
					xyzcheck
					@plinelist.push [@pts,@ly,@bg,@close]
					Sketchup.set_status_text "Find:POLYLine"
				end
				init_att
				checkSec line1,line2
			else
				get_att line1,line2
			end
		else
		 return false
		end
		return true
	end

	def defin_block( blockname , opt = Geom::Point3d.new( 0,0,0 ) )
		@two_d = true
		model = Sketchup.active_model
		blockname = "block-" + blockname
		tg = model.definitions[ blockname ]
		if tg == nil
			tg = model.definitions.add blockname
			#tg.entities.add_cpoint( [0,0,0] )
		end
		if opt.class == Geom::Point3d
			#p opt
		else
			opt = Geom::Point3d.new( 0,0,0 )
		end
		#UI.messagebox blockname
		#tg.insertion_point = opt
		tr = Geom::Transformation.translation( opt.vector_to( [0,0,0] ) )
		
		tgadd_entities tg
		
		ents = tg.entities.collect{|e| e }
		tg.entities.transform_entities( tr , ents )
	#exit
	end
	def set_layer( ele , ly , chk = false)
		if ele and ly and ly!= "" and Sketchup.active_model.layers[ ly ]
			if ele.kind_of?( Array )
				ele.each{|e| e.layer = ly}
			else
				ele.layer = ly
				if chk == true
					ele.edges.each{|ped| ped.layer = ly }
				end
			end
		end
	end
	def check_grp_polygons( grphash )
		if grphash and grphash.entities.count > 8000
			grptemp = grphash.parent.entities.add_group
			grptemp.name = countup_name( grphash.name )
			grphash = grptemp
		end
	end
	def tgadd_entities( tg , tr = Geom::Transformation.new )#tg is definition or group
		#be_onoff = Sketchup.break_edges?
		#Sketchup.break_edges = false
		#p tg.name
		#tg.entities.add_cpoint( [0,0,0] )
		model = Sketchup.active_model
		@lylist.each{|ly|
			begin
				model.layers.add ly
			rescue
				@errlist.push [ "LAYER" , ly ]
			end
		}

		allcount = @textlist.size
		count = 0
		definitions = model.definitions
		if @chkText == "3D TEXT" or @chkText == "3D TEXT(NO EDGES)"
			mats = Sketchup.active_model.materials
			bkmat = mats[ "Black" ]
			bkmat = mats.add( "Black" ) if not bkmat

			txcnt = 0
			#textgp = nil
			#if not textgp or textgp == nil or not textgp.valid?
			textgp = tg.entities.add_group
			textgp.name = "[TEXT_GROUP]"
			textgp.entities.add_cpoint([0,0,0])
			#end
			for i in (0..allcount)
			
				tlist = @textlist[i]
				break if tlist == nil
				txt,pt,ly,th,rot,justyf = tlist
				#txt = NKF.nkf('-xW', txt)
				if txt != "" and txt != nil and strip_all( txt ) != ""
					cdef = definitions[ "[TEXT]" + txt ]
					theight = @tsc * 2 / 2.54 * th
					ret = false
					if cdef == nil
						cdef = definitions.add "[TEXT]" + txt
						#cdef.entities.add_cpoint([0,0,0])
						#fontslist = [@cfont]
						fontslist = [""]#,"Arial"]#,"Simplex","ＭＳ Ｐゴシック","MS Pゴシック","日本語フォント","Osaka"] #"ＭＳ Ｐゴシック","MS Pゴシック","日本語フォント","Osaka",
						ret = false
						fontname = ""
						fontslist.each{|fontname|
							#p txt
							begin
								ret = cdef.entities.add_3d_text( txt , TextAlignLeft , fontname , false, false, 1.0 , 2.0, 0.0, true, 0.0 )
							rescue
								ret = false
							end
							if ret == true
								#p "font=#{fontname}"
								break
							end
						}
						
						if ret == true and cdef and cdef.valid? and cdef.entities.count > 0
							#edgrp = cdef.entities.add_group( cdef.entities.find_all{|e| e.kind_of? Sketchup::Edge } )
							#edgrp.visible = false
							if @chkText == "3D TEXT(NO EDGES)"
								cdef.entities.each{|e|
									e.hidden = true if e.kind_of?( Sketchup::Edge )
								}
							end
							cdef.set_attribute("TT_Editor3dText","Align","Left")
							cdef.set_attribute("TT_Editor3dText","Extruded",true)
							cdef.set_attribute("TT_Editor3dText","Extrusion",0.mm)
							cdef.set_attribute("TT_Editor3dText","Filled",true)
							cdef.set_attribute("TT_Editor3dText","Font",fontname)
							cdef.set_attribute("TT_Editor3dText","Size",1)
							cdef.set_attribute("TT_Editor3dText","Style","Normal")
							cdef.set_attribute("TT_Editor3dText","Text",txt)
						end
					else
						ret = true
					end
					@errlist.push [ "3DTEXT" , txt ] if ret == false
					
					if ret == true and cdef and cdef.valid? and cdef.entities.count > 0
						#if justyf == "Center"
						#	t = Geom::Transformation.translation( Geom::Vector3d.new( - cdef.bounds.width / 2 * theight ,0,0 ) )
						#elsif justyf == "Right"
						#	t = Geom::Transformation.translation( Geom::Vector3d.new( - cdef.bounds.width * theight ,0,0 ) )
						#else
							t = Geom::Transformation.translation( Geom::Vector3d.new( 0 ,0, 1.mm ) )
						#end
						
						if rot != 0
							t = Geom::Transformation.translation( Geom::Point3d.new( 0,0,0 ).vector_to( pt ) ) * Geom::Transformation.rotation(  Geom::Point3d.new( 0,0,1 ) , Geom::Vector3d.new( 0,0,1 ) , rot.degrees ) * Geom::Transformation.scaling( theight ) * t
						else
							t = Geom::Transformation.translation( Geom::Point3d.new( 0,0,0 ).vector_to( pt ) ) * Geom::Transformation.scaling( theight ) * t
						end
						begin
							ci = textgp.entities.add_instance cdef , t
						rescue
							p "error:text:#{cdef.name}"
						end

						if ci.valid?
							ci.material = bkmat
							set_layer( ci , ly )
						end
						#ci.layer = ly if ly and ly!= "" and model.layers[ ly ]
					else
						#p "error:text=#{txt}"
					end
					Sketchup.set_status_text "creating text:#{count}//#{allcount}:TEXT-GROUP-#{txcnt}//#{txt}" if ( txcnt % 10 ) == 0
					count += 1
				end#if txt
			end#for
		elsif @chkText == "2D TEXT"
			txcnt = 0
			for i in (0..allcount)
				tlist = @textlist[i]
				break if tlist == nil
				txt,pt,ly,th,rot,justyf = tlist
				if txt != "" and txt != nil
					tele = tg.entities.add_text txt,pt
					tele.leader_type = 0
					set_layer( tele , ly )
					#tele.layer = ly if ly and ly!= "" and model.layers[ ly ]
					Sketchup.set_status_text "creating text:#{count}//#{allcount}:TEXT-GROUP-#{txcnt}//#{txt}" if ( txcnt % 10 ) == 0
					count += 1
				end#if txt
			end#for
		end# @chkText

		grphash= Hash.new
		grphash[""]  = tg
		@lylist.each{|ly|
			grphash[ly] = tg.entities.add_group
			grphash[ly].name = "[GROUP]" + ly
		}

		allcount = @linelist.size
		count = 0
		#UI.messagebox allcount
		@linelist.each{|llist|
			break if llist == nil
			pts,ly = llist
			#UI.messagebox "#{ly}:#{pts[0].x},#{pts[0].y},#{pts[0].z}:#{pts[1].x},#{pts[1].y},#{pts[1].z}"
#			if ly != ""

				if @with_cline == true
					lele = grphash[ly].entities.add_cline pts[0],pts[1]
					set_layer(lele,ly)
				else
					lele = grphash[ly].entities.add_line pts[0],pts[1]
					set_layer(lele,ly)
				end

				check_grp_polygons( grphash[ly] )
		
			Sketchup.set_status_text "creating line:#{count}//#{allcount}" if ( count % 10 ) == 0
			count += 1
		}
		allcount = @plinelist.size
		count = 0
		@plinelist.each{|plist|
			break if plist == nil
			pts,ly,buldge,clo,spl = plist
			#UI.messagebox "#{pts.size},#{buldge.size}"
			if buldge.find_all{|b| b != 0.0 }.size == 0
#				if ly != ""
					edgr = grphash[ly]
					pcnt= pts.size - 2
					if clo == false and @with_cline == true
						if spl == false
							#pele2 = edgr.entities.add_cpoint pts[0]
							#pele2.layer = ly
						end
						for i in ( 0..pcnt )
							pt1 = pts[i]
							pt2 = pts[i+1]
							pele = edgr.entities.add_cline pt1,pt2
							set_layer( pele, ly )
							#pele.layer = ly if pele and ly and ly != "" and model.layers[ ly ]
							if spl == false
								#pele2 = edgr.entities.add_cpoint pt2
								#pele2.layer = ly if pele2
							end
						end
					elsif @with_face != true
						for i in ( 0..pcnt )
							pt1 = pts[i]
							pt2 = pts[i+1]
							pele = edgr.entities.add_line pt1,pt2
							set_layer( pele , ly )
							#pele.layer = ly if pele and ly and ly != "" and model.layers[ ly ]
						end
					else
						pts.uniq!
						pele = edgr.entities.add_face pts
						set_layer( pele , ly , true )
						#if pele and ly and ly != "" and model.layers[ ly ]
						#	pele.layer = ly
						#	pele.edges.each{|ped| ped.layer = ly }
						#end
					end
					check_grp_polygons( grphash[ly] )

			else#if buldge.find_all{|b| b != 0.0 }.size != 0
#				if ly != ""
					edgr = grphash[ly]
					pcnt= pts.size - 2
					if spl == false and clo == false and @with_cline == true
						pele2 = edgr.entities.add_cline pts[0]
						pele2.layer = ly if pele2 and ly and ly != "" and model.layers[ ly ]
					end
					for i in ( 0..pcnt )
						pt1 = pts[i]
						pt2 = pts[i+1]
						bdg = buldge[i+1]
						if bdg == 0.0
							if clo == false and @with_cline == true
								pele = edgr.entities.add_cline pt1,pt2
								set_layer( pele , ly )
								#pele.layer = ly if pele and ly and ly != "" and model.layers[ ly ]
								if spl == false
									pele2 = edgr.entities.add_cline pt2
									set_layer( pele2, ly )
									#pele2.layer = ly if pele2
								end
							else
								pele = edgr.entities.add_line pt1,pt2
								set_layer( pele, ly )
								#pele.layer = ly if pele and ly and ly != "" and model.layers[ ly ]
							end
						else
							create_arc( edgr , pt1, pt2 , bdg , ly )
						end
					end
					check_grp_polygons( grphash[ly] )

			end
			Sketchup.set_status_text "creating pline:#{count}//#{allcount}" if ( count % 10 ) == 0
			count += 1
		}
		allcount = @circlelist.size
		count = 0
		@circlelist.each{|clist|
			break if clist == nil
				#UI.messagebox "nil"
			pt,radius,ly = clist
			#maxdiv = Math.log(radius.to_mm.to_f).to_i * @divtole
			#maxdiv = 18 * @divtole if maxdiv > 18 * @divtole
			maxdiv = ( 1 + radius / @divtole ).to_i * 12
			maxdiv = 360 if maxdiv > 360
			maxdiv = 4 if maxdiv < 4
			if @circle2comp > radius
				cirname = "[CIRCLE]" + maxdiv.to_s
				cdef = definitions[ cirname ]
				if cdef == nil
					cdef = definitions.add cirname
					cdef.entities.add_circle [0,0,0],Geom::Vector3d.new(0,0,1),1.0,maxdiv
				end
				t = Geom::Transformation.scaling( [0,0,0] , radius )
				t = Geom::Transformation.translation( Geom::Point3d.new( 0,0,0 ).vector_to( pt ) ) * t
				#if ly != ""
					cirele = grphash[ly].entities.add_instance cdef , t
					set_layer( cirele , ly )
					#cirele.layer = ly if cirele != nil and ly != "" and model.layers[ ly ]
				#else
				#	tg.entities.add_instance cdef , t
				#end
			else
				#if ly != ""
					cirele = grphash[ly].entities.add_circle pt,Geom::Vector3d.new(0,0,1),radius,maxdiv
					cirele.each{|cir| cir.layer = ly } if cirele != nil and ly != "" and model.layers[ ly ]
					#cele.layer = ly if cele != nil
				#else
				#	tg.entities.add_circle pt,Geom::Vector3d.new(0,0,1),radius
				#end
			end
			Sketchup.set_status_text "creating circle:#{count}//#{allcount}" if ( count % 10 ) == 0
			count += 1
		}
		allcount = @arclist.size
		count = 0
		@arclist.each{|alist|
			break if alist == nil

			pt,radius,st,en,ly = alist
			ang = (720 + en - st) % 360
			#@divtole = 4
			#maxdiv = Math.log(radius.to_mm.to_f).to_i * @divtole
			#maxdiv = 18 * @divtole if maxdiv > 18 * @divtole
			maxdiv = ( 1 + radius / @divtole ).to_i * 12
			maxdiv = 360 if maxdiv > 360
			maxdiv = 4 if maxdiv < 4
			
			maxdiv = ( maxdiv * ang / 360 ).to_i
			maxdiv = 2 if maxdiv < 2
			n = Geom::Vector3d.new(0,0,1)
			en = st + ang
			
			#if ly != ""
				arele = grphash[ly].entities.add_arc pt,Geom::Vector3d.new(1,0,0),n,radius,st.degrees,en.degrees,maxdiv
				set_layer( arele , ly )
				#arele.each{|ar| ar.layer = ly } if arele != nil and ly != "" and model.layers[ ly ]
				check_grp_polygons( grphash[ly] )

			#else
			#	tg.entities.add_arc pt,Geom::Vector3d.new(1,0,0),n,radius,st.degrees,en.degrees,maxdiv
			#end
			Sketchup.set_status_text "creating arc:#{count}//#{allcount}" if ( count % 10 ) == 0
			count += 1
		}
		allcount = @ellilist.size
		count = 0
		@ellilist.each{|elist|
			break if elist == nil

			cpt,vec_e,ratio,st,en,ly = elist
			
			if ly != ""
				elpgr = grphash[ly]
			else
				elpgr = tg
			end
			create_ellipse elpgr , cpt , vec_e , ratio , st , en , ly

			Sketchup.set_status_text "creating ellipse:#{count}//#{allcount}" if ( count % 10 ) == 0
			count += 1
		}
		allcount = @blocklist.size
		count = 0
		definitions = model.definitions
		
		@blocklist.each{|tlist|
			break if tlist == nil
			blck,pt,ly,sc,rot = tlist
			if blck != "" and blck != nil
				blck = "block-" + blck
				sc = 1 if sc == 0
				ci = definitions[blck]
				#20130127
				if ci == nil
					ci = definitions.add( blck )
					ci.entities.add_cpoint([0,0,0])
				end
				if ci != nil
					t = Geom::Transformation.translation( [0,0,0].vector_to( pt ) ) * Geom::Transformation.rotation( [0,0,0] , Geom::Vector3d.new( 0,0,1 ) , rot.degrees ) * Geom::Transformation.scaling( sc.abs )
					tg.entities.add_instance ci, t
				end
				#20130127-
				Sketchup.set_status_text "creating block:#{count}//#{allcount}" if ( count % 10 ) == 0
				count += 1
			end
		}	
	end
	def create_ellipse( gr , cpt , rpt , ratio , st , en , ly )

		#UI.messagebox "#{st},#{en}"
		vec_e = [0,0,0].vector_to( rpt )
		#vec_e = cpt.vector_to( rpt )
		radius = vec_e.length
		st = st * 180 / Math::PI
		en = en * 180 / Math::PI
		#UI.messagebox "#{st},#{en}"
		ang = en - st
		if st == 0 and en == 0
			en = 360
			ang = 360
		end
		#maxdiv = Math.log(radius.to_mm.to_f).to_i * @divtole * 2 
		#maxdiv = 36 * @divtole if maxdiv > 36 * @divtole
		maxdiv = ( 1 + radius / @divtole ).to_i * 12
		maxdiv = 360 if maxdiv > 360
		
		maxdiv = 4 if maxdiv < 4
		maxdiv = ( maxdiv * ang / 360 ).to_i
		maxdiv = 2 if maxdiv < 2
		nvec = Geom::Vector3d.new(0,0,1)
		#en = st + ang
		
		gr2 = gr.entities.add_group
		gr2.entities.add_arc [0,0,0] ,Geom::Vector3d.new(1,0,0),nvec,radius,st.degrees,en.degrees,maxdiv
	
		rotxy = Math.atan2( vec_e.y , vec_e.x )
		t = Geom::Transformation.scaling(1.0 , ratio , 1.0)
		t = Geom::Transformation.rotation( [0,0,0], nvec , rotxy ) * t
		t = Geom::Transformation.translation( cpt ) * t
		gr2.entities.transform_entities( t , gr2.entities.collect{|e| e } )
		gr2.explode
	end
	def countup_name( grpname )
		if grpname[/(.*)--(\d*)$/]
			newname = "#{$1}--#{$2.to_i + 1}"
		else
			newname = "#{grpname}--1"
		end
		return newname
	end
	def create_arc( grp , pt1, pt2 , bl , ly )
		angbl = Math.atan2( bl , 1 )
		ang = ( 4.0 - Math::PI / angbl.abs ) * angbl / 2

		radius = ( pt1.distance( pt2 ) / 2 / Math.cos( ang ) ).abs

		n = Geom::Vector3d.new(0,0,1)
		vec = pt1.vector_to( pt2 )
		vec.length = radius
		t= Geom::Transformation.rotation( pt1, n , - ang ) * Geom::Transformation.translation( vec )
		cpt = pt1.transform( t )
		
		vecCA = cpt.vector_to( pt1 )
		vecCB = cpt.vector_to( pt2 )

		st = ( Math.atan2( vecCA.y , vecCA.x ) * 180 / Math::PI + 360 ) % 360
		en = ( Math.atan2( vecCB.y , vecCB.x ) * 180 / Math::PI + 360 ) % 360
		st , en = en , st if bl < 0
		en = en + 360 if st > en

		ang4 = en - st
		#maxdiv = Math.log( radius.to_mm ).to_i * @divtole * 2
		#maxdiv = 36 * @divtole if maxdiv > 36 * @divtole
		maxdiv = ( 1 + radius / @divtole ).to_i * 12
		maxdiv = 360 if maxdiv > 360
		maxdiv = 4 if maxdiv < 4
		
		maxdiv = ( maxdiv * ang4.abs / 360 ).to_i
		maxdiv = 2 if maxdiv < 2

		eds = grp.entities.add_arc cpt,Geom::Vector3d.new(1,0,0),n,radius,st.degrees,en.degrees,maxdiv
		if eds and ly != ""
			eds.each{|ed| ed.layer = ly }
		end
	end
	def strip_all( txt )
		txt2 = "#{txt}"
		spacelist = []
		spacelist.push "0009"
		spacelist.push "000A"
		spacelist.push "000B"
		spacelist.push "000C"
		spacelist.push "000D"
		spacelist.push "0020"
		spacelist.push "0085"
		spacelist.push "00A0"
		spacelist.push "1680"
		spacelist.push "180E"
		spacelist.push "2000"
		spacelist.push "2001"
		spacelist.push "2002"
		spacelist.push "2003"
		spacelist.push "2004"
		spacelist.push "2005"
		spacelist.push "2006"
		spacelist.push "2007"
		spacelist.push "2008"
		spacelist.push "2009"
		spacelist.push "200A"
		spacelist.push "2028"
		spacelist.push "2029"
		spacelist.push "202F"
		spacelist.push "205F"
		spacelist.push "3000"
		txt2.strip!
		spacelist.each{|spword|
			txt2.gsub!(["0x#{spword}".hex].pack( "U*" ),"")
		}
		return txt2
	end
	def init_arrays
		@textlist = []
		@linelist = []
		@plinelist = []
		@circlelist = []
		@arclist = []
		@blocklist = []
		@lylist = []
		@ellilist = []
	end
	def addnil_arrays
		@textlist.push nil
		@linelist.push nil
		@plinelist.push nil
		@circlelist.push nil
		@arclist.push nil
		@ellilist.push nil
	end
	def xyzcheck
		@pts = []
		@x.each_with_index{|x,i|
			@y[i] = 0 unless @y[i]
			@z[i] = 0 unless @z[i]
			@bg[i] = 0 unless @bg[i]
			@pts.push Geom::Point3d.new( x.to_f , @y[i].to_f  , @z[i].to_f )
			#UI.messagebox "#{x.to_f} , #{@y[i].to_f} , #{@z[i].to_f} "
		}
		#p @drscale
		#@bg.push @bulge
		#UI.messagebox "#{@bg.size}"
		@pts.push @pts[0] if @close == true
	end
	def correct_text( txt )
		txt.gsub!(/\\P/,"")
		txt.gsub!(/\\[^;]*\;/,"")
		###シンボル文字の変換
		txt.gsub!('%%P',"±")
		txt.gsub!('%%C',"φ")
		txt.gsub!('%%D',"°")
		txt.gsub!('%%%',"%")
		txt.gsub!('%%U',"")
		txt.gsub!('%%O',"")
		glist = txt.scan(/\\U\+([0123456789ABCDEF]{4})/)
		glist.uniq!
		glist.each{|gwrd|
			txt.gsub!('\U+'+gwrd[0] , ["0x#{gwrd[0]}".hex].pack( "U*" ) )
		}
		return txt
			#@txt.gsub!('\U+2248',"≒")
			#@txt.gsub!('\U+2220',"∠")
			#@txt.gsub!('\U+E100',"BL")
			#@txt.gsub!('\U+2104',"CL")
			#@txt.gsub!('\U+0394',"Δ")
			#@txt.gsub!('\U+0278',"Φ")
			#@txt.gsub!('\U+E101',"FL")
			#@txt.gsub!('\U+2261',"≡")
			#@txt.gsub!('\U+E200',"ρ")
			#@txt.gsub!('\U+E102',"ML")
			#@txt.gsub!('\U+2260',"≠")
			#@txt.gsub!('\U+2126',"Ω")
			#@txt.gsub!('\U+03A9',"Ω")
			#@txt.gsub!('\U+214A',"PL")
			#@txt.gsub!('\U+2082',"")#下付き文字
			#@txt.gsub!('\U+00B2',"^2")
			#@txt.gsub!('\U+00B3',"^3")
	end
	def get_only_textline( line1,line2 )
		if line1.to_s == "1"
			txt = correct_text( line2.to_s )
		elsif line1.to_s == "8"
			txt = line2.to_s
		end
		return txt
	end
	def get_att( line1 , line2 )

		if line1.to_s == "1"
			@txt = correct_text( line2.to_s )
		elsif line1.to_s == "0" and line2.to_s == "VERTEX" and @starthwpline == true
			@startseq = true
		elsif line1.to_s == "2"
			@name = line2.to_s
		elsif line1.to_s == "10" or line1.to_s == "11"
			if @starthwpline == true and @startseq == false
			else
				@x.push line2.to_f * @drscale #if @inch == false
				#@x.push line2.to_f if @inch == true
				@bg.push @bulge if @startpline == true
				#UI.messagebox "#{@startpline},#{line2},#{@x.size},#{@bg.size}"
				@bulge = 0.0
			end
		elsif line1.to_s == "20" or line1 == "21"
			if @starthwpline == true and @startseq == false
			else
				@y.push line2.to_f * @drscale#.mm if @inch == false
				#@y.push line2.to_f if @inch == true
			end
		elsif line1.to_s == "30" or line1.to_s == "31"
			if @starthwpline == true and @startseq == false
			else
				if @two_d == true
					@z.push 0.to_f * @drscale#.mm if @inch == false
					#@z.push 0.to_f if @inch == true
				else
					@z.push line2.to_f * @drscale#.mm if @inch == false
					#@z.push line2.to_f if @inch == true
				end
			end
		elsif line1.to_s == "40"
			@radius = line2.to_f * @drscale
			@scale =  line2.to_f
			#if @inch == false
			#	@radius = line2.to_f.mm
			#	@scale =  line2.to_f.mm
			#else
			#	@radius = line2.to_f
			#	@scale =  line2.to_f
			#end
			@ratio = line2.to_f if @startelli == true
		elsif line1.to_s == "41"
			@scale = line2.to_f# * @drscale#.mm if @inch == false
			#@scale = line2.to_f if @inch == true
			@stang = line2.to_f if @startelli == true
		elsif line1.to_s == "42"
			@bulge = line2.to_f if @startpline == true
			@enang = line2.to_f if @startelli == true
		elsif line1.to_s == "50"
			@stang = line2.to_f if @startelli == false
		elsif line1.to_s == "51"
			@enang = line2.to_f if @startelli == false
		elsif line1.to_s == "70"
			@close = true if ( line2.to_i & 1 ) == 1
			#p "close" + line2 if ( line2.to_i & 1 ) == 1
			#@close = true if line2 == "1" or line2 == "16" or line2 == "32" or line2 == "64"
			@type = true if line2 == "0"
			if line2.to_i == 128 and @starthwpline == true and @startseq == true
				@x.delete_at( @x.size - 1 )
			end
		elsif line1.to_s == "71" and @startmtext == true
			if line2.to_i == 2 or line2.to_i == 5 or line2.to_i == 8
				@justyf = "Center"
			elsif line2.to_i == 3 or line2.to_i == 6 or line2.to_i == 9
				@justyf = "Right"
			else
				@justyf = "Left"
			end
		elsif line1.to_s == "72" and @starttext == true
			if line2.to_i == 1
				@justyf = "Center"
			elsif line2.to_i == 2
				@justyf = "Right"
			else
				@justyf = "Left"
			end
		elsif line1.to_s == "100"
			@type2 = line2
		elsif line1.to_s == "8"
			@ly = line2.to_s
			@lylist.push @ly if @lylist.index(@ly) == nil
		end
	end
	def init_att
		
		@startpline = false
		@startline = false
		@starttext = false
		@startmtext = false
		@startcircle = false
		@startarc = false
		@starthwpline = false
		@startseq = false
		@startelli = false
		@startspline = true
		@close = false
		@bulge = 0.0
		@raito = 1.0
		@name = ""
		@txt = ""
		@justyf = "Left"
		@x = []
		@y = []
		@z = []
		@bg = []
		@h = 0
		@radius = 0
		@scale = 1
		@ly = ""
		@stang = 0
		@enang = 0
		@nx = 0
		@ny = 0
		@nz = 0
		@pts = []

	end
	def checkSec(line1,line2)
		if line2.upcase == "TEXT" or line2.upcase == "MTEXT" or line2.upcase == "ATTRIB"
			@starttext = true
		elsif line2.upcase == "LINE"
			@startline = true
		elsif line2.upcase == "LWPOLYLINE" or line2.upcase == "SPLINE"
			@startpline = true
			@startspline = true if line2.upcase == "SPLINE"
		elsif line2.upcase == "POLYLINE"
			@starthwpline = true
		elsif line2.upcase == "CIRCLE"
			@startcircle = true
		elsif line2.upcase == "ELLIPSE"
			@startelli = true
		elsif line2.upcase == "ARC"
			@startarc = true
		elsif line2.upcase == "BLOCK"
			@startblockdef = true
		elsif line2.upcase == "INSERT"
			@startblock = true
		elsif line2.upcase == "ENDBLK"
			@endblk = true
		end
	end
	def update_definitions( ents )
		inslist=[]
		klist = []
		ents.find_all{|e| e.kind_of? Sketchup::ComponentInstance }.each{|ci|
			if ci.definition.name[/#####dummy/]
				rname = ci.definition.name.gsub(/#####dummy/,"")
				rdf = Sketchup.active_model.definitions[rname]
				if rdf
					tr = ci.transformation
					inslist.push [ rdf , tr.clone ]
				end
			end
		}
		inslist.each{|rdf , tr | ents.add_instance( rdf , tr ) }
		klist = ents.find_all{|e| e.kind_of? Sketchup::ComponentInstance }.find_all{|ci| ci.definition.name[/#####dummy/] }
		ents.erase_entities klist
	end
	def face_from_twolines()
		model = Sketchup.active_model
		ents = model.active_entities
		sels = model.selection
		eds = sels.find_all{|e| ( e.kind_of? Sketchup::Edge and e.curve == nil ) or e.kind_of? Sketchup::ConstructionLine }
		p "Edges:#{eds.size}"
		model.start_operation langconv("Create Faces from Two Edges.")# , true 
		if eds.size == 2
			pts , ly  = create_face_from_twoedges( eds[0] , eds[1] )
			ents.add_face pts
			if ly != ""
				fc.layer = ly
				fc.edges.each{|ed| ed.layer = ly }
			end
		elsif eds.size > 2
			#複数エッジが選択されている場合
			#閾値となる距離を決める。その幅以上の離れの場合は拾わない
			#同じ方向のエッジをグループとして考える？
			#基本的にはptsにためて面を新規追加するのでエッジ要素自体をストアしなくてもいける
			
			ssdf = Sketchup.read_default( "Structure Tool" , "BST_FACE_FROM_EDGES" )
			dist = 2540.mm
			if ssdf
				p ssdf
				testarray = eval(ssdf)
				dist = testarray[0]
				p dist
			end
			prompts = [ langconv("DISTANCE") ]
			defaults = [ dist.to_s ]
			result = UI.inputbox prompts, defaults, langconv("Create Faces from Two Edges.")
			return nil if result == nil || result == false
		
			dist = result[0].to_l if result[0]
			Sketchup.write_default( "Structure Tool" , "BST_FACE_FROM_EDGES" , [ dist.to_s ].inspect.gsub( 34.chr , "'"))

			ptss = []
			while eds != []
				ed1 = eds.delete_at(-1)
				Sketchup::set_status_text "Remained:#{eds.size}"
				dist2 = dist + 0.mm
				ed2_in = []
				eds.each_with_index{|ed2,i|
					pt_1s, pt_1e , vec1 = get_start_end( ed1 )
					pt_2s, pt_2e , vec2 = get_start_end( ed2 )
					line1 = [ pt_1s , vec1 ]
					line2 = [ pt_2s , vec2 ]
					len1 = pt_1s.distance( pt_1e )
					len2 = pt_2s.distance( pt_2e )
					ang = vec1.angle_between( vec2 ).radians
					#エッジ同志の交わる角度が0.2ど程度までに限定する
					#p pt_1s.distance_to_line( line2 )
					if ( ang > 0.2 and ang < 179.8 )
					#平行で距離が1.mm未満の場合は不可とする
					elsif  pt_1s.distance_to_line( line2 ) >= 1.mm
						#p pt_1s.distance_to_line( line2 )
							mdist = []
							#各頂点とエッジまでの距離が十分近いかを判定
							ipt1 = pt_1s.project_to_line( line2 )
							ipt2 = pt_1e.project_to_line( line2 )
							ipt3 = pt_2s.project_to_line( line1 )
							ipt4 = pt_2e.project_to_line( line1 )
							#任意の頂点と各エッジまでの距離の合計と比較してエッジの長さが短ければ、その頂点はエッジ上にない
							mdist.push pt_1s.distance_to_line( line2 ) if ( ( ipt1.distance( pt_2s ) + ipt1.distance( pt_2e ) ) / len2 ) < 1.001
							mdist.push pt_1e.distance_to_line( line2 ) if ( ( ipt2.distance( pt_2s ) + ipt2.distance( pt_2e ) ) / len2 ) < 1.001
							mdist.push pt_2s.distance_to_line( line1 ) if ( ( ipt3.distance( pt_1s ) + ipt3.distance( pt_1e ) ) / len1 ) < 1.001
							mdist.push pt_2e.distance_to_line( line1 ) if ( ( ipt4.distance( pt_1s ) + ipt4.distance( pt_1e ) ) / len1 ) < 1.001
							mdist.delete( nil )
							begin
								mdist.min
							rescue
								p mdist
							end
							if mdist != [] and mdist.min < dist2
								dist2 = mdist.min
								ed2_in = [ i ]
							end
					end
				}
				if ed2_in != []
					i = ed2_in[0]
					ed2 = eds.delete_at(i)
					ptss.push create_face_from_twoedges( ed1 , ed2 )
				end
			end
			err = 0
			succ = 0
			ptss.each{|pts,ly|
				if pts
					begin
						fc = ents.add_face pts
						if ly != ""
							fc.layer = ly
							fc.edges.each{|ed| ed.layer = ly }
						end
						succ += 1
					rescue
						err += 1
					end
				end
			}
			p "Face:#{succ}--Error:#{err}"
		end
		model.commit_operation
	end
	def get_start_end( ed )
		if ed.kind_of? Sketchup::Edge
			pt_s = ed.start.position
			pt_e = ed.end.position
			vec = pt_s.vector_to( pt_e )
			return pt_s, pt_e , vec
		else
			pt_s = ed.start
			pt_e = ed.end
			vec = pt_s.vector_to( pt_e )
			return pt_s, pt_e , vec
		end
	end
	def create_face_from_twoedges( ed1, ed2 )
		#ed1 , ed2 = eds
		ly = ed1.layer.name
		ly = "" if ly != ed2.layer.name
		pt_1s, pt_1e , vec1 = get_start_end( ed1 )
		pt_2s, pt_2e , vec2 = get_start_end( ed2 )
		line = [ [ pt_1s , vec1 ] , [ pt_2s,vec2 ] ]
		#line = [ eds[0].line , eds[1].line ]
		ang = vec1.angle_between( vec2 ).radians
		i0 , i1 = pt_2s , pt_2e
		if ang > 90
			i0 , i1 = pt_2e , pt_2s
		end
		pts = []
		pts.push pt_1s
		if pt_1s != i0
			pts.push i0
		end
		pts.push i1
		if pt_1e != i1
			pts.push pt_1e
		end
		if pts.size > 2
			return pts ,ly
		end
		return nil
	end
	def create_face_from_nonplaner_edges()
		model = Sketchup.active_model
		ents = model.active_entities
		sels = model.selection
		seleds = sels.find_all{|e| e.kind_of? Sketchup::Edge }
		return if seleds == []
		model.start_operation("Create Face from nonplaner edges",true)
		grp1 = ents.add_group( seleds )
		grp = grp1.copy
		grp1.explode
		gents = grp.entities
		gcrvs = gents.find_all{|e| e.kind_of? Sketchup::Edge }.map{|ed| ed.curve }.uniq
		#each{|cr|
		#	if cr
		#		cr.edges.map{|ed| [ ed.start.position , ed.end.position ] }.each{|pts| gents.add_edges pts }
		#	end
		#}
		gedgs = gents.find_all{|e| e.kind_of? Sketchup::Edge }
		gvts = gedgs.map{|ed| ed.vertices }.flatten.uniq
		gedgs = gents.find_all{|e| e.kind_of? Sketchup::Edge and e.curve == nil}
		svts = gvts.find_all{|vt| vt.edges.size == 1 }
		if svts.size == 2
			gents.add_edge svts.map{|vt| vt.position }
		elsif svts.size > 2
			UI.message("not closed!")
			model.abort_operation
			return
		end
		gpts = gvts.map{|vt| vt.position }
		geds_2pts = gedgs.map{|ed| ed.vertices.map{|vt| vt.position } }
		gnormal = Geom::Vector3d.new(0,0,0)
		gvts.find_all{|vt|
			if vt.edges.size >= 2
				gnormal = gnormal + vt.edges[0].line[1].cross( vt.edges[1].line[1] )
			end
		}
		gorigin = gvts[0].position
		
		if gnormal.length > 0.0
			gnormal.normalize!
			plane = [ gorigin , gnormal ]
			newverts = []
			transvecs = []
			invvecs = []
			gpts = gvts.map{|vt| vt.position }
			newpts = gpts.map{|pt| pt.project_to_plane( plane ) }
			newpts.length.times{|t|
				if newpts[t-1] == newpts[t]
					3.times{|i| newpts[t-1][i] = ( newpts[t-2][i] + newpts[t][i] / 2 ) }
				end
				transvecs[t] = gpts[t].vector_to( newpts[t] )
				invvecs[t] = newpts[t].vector_to( gpts[t] )
			}
			gents.transform_by_vectors( gvts , transvecs )
			gedgs.each{|ed| ed.find_faces }
			gents.transform_by_vectors( gvts , invvecs )
			#klist = []
			gents.each{|e|
				if e.kind_of? Sketchup::Edge 
					if e.faces.size == 2
						e.smooth = e.soft = true
					end
				end
			}
			#gents.erase_entities(klist) if klist != []
			grp.explode
		end
		model.commit_operation
	end
	def update_all_definitions()
		dfs = Sketchup.active_model.definitions
		dfs.each{|df|
			update_definitions( df.entities )
		}
	end
	
	def test_component()
		model = Sketchup.active_model
		defs = model.definitions
		testdef = defs.add( "test1" )
		testdef.entities.add_cpoint([0,0,0])
		
		testdef2 = defs.add("test2")
		testdef2.entities.add_instance( testdef , Geom::Transformation.new )
		model.active_entities.add_instance( testdef2 , Geom::Transformation.new )
		
		testdef.entities.add_face([0,0,0],[1,0,0],[1,1,0],[0,1,0])
	end
	def add_edge_to_near_vertices()
		model = Sketchup.active_model
		ents = model.active_entities
		sels = model.selection
		stray_vts = []
		sels.each{|e|
			if e.kind_of? Sketchup::Face or e.kind_of? Sketchup::Edge
				e.vertices.each{|vt|
					if vt.edges.length == 1 and not stray_vts.include?( vt )
						stray_vts.push vt
					end
				}
			end
		}
		#not_stray = stray_vts.map{|vt| vt }
		stray_vts.each{|vt|
			vt2 = stray_vts.find{|nvt| nvt.position.distance( vt.position ) < 50.mm and nvt.position.distance( vt.position ) > 0.0 }
			if vt2
				ents.add_line( vt.position , vt2.position )
			end
		}
	end
	def add_dxftextiimport_menus()
		tak_dxf_menu = UI.menu("Files").add_submenu( langconv("2D-DXF IMPORT") )
		tak_dxf_menu.add_item( langconv("IMPORT") ) { 
			startimport
		}
		tak_dxf_menu.add_item( langconv("Import ThreeView DXF") ) {
			import_trihedra_drawings
		}
		tak_dxf_menu.add_item( langconv("Add lines between near points") ) {
			add_edge_to_near_vertices
		}
		tak_dxf_menu.add_item( langconv("Create Faces from Two Edges.") ) {
			face_from_twolines
		}
		tak_dxf_menu.add_item( langconv("Create face from NonPlaner Edges.") ) {
			create_face_from_nonplaner_edges
		}
		tak_dxf_menu.add_item( langconv("Change Language File") ) {
			select_langfile
		}

		icon_tak_dxf = File.join( File.dirname( File.expand_path(__FILE__) ), "icon_trihedral_imp.png" )
		icon_tak_faceedges = File.join( File.dirname( File.expand_path(__FILE__) ), "icon_face_2edges_lg.png" )
		icon_tak_nonplaner = File.join( File.dirname( File.expand_path(__FILE__) ), "icon_face_nonplaner_lg.png" )
		#icon_tak_dxf = Sketchup.find_support_file "icon_trihedral_imp.png", "Plugins/dxftext_import/"
		#pdir = File.dirname( File.expand_path(__FILE__) ) + '/fur_en'

		tak_dxf_tool_trihedral = UI::Command.new(langconv("Import ThreeView DXF")) {
			import_trihedra_drawings
		}
		tak_dxf_tool_trihedral.large_icon = tak_dxf_tool_trihedral.small_icon = icon_tak_dxf
		tak_dxf_tool_trihedral.status_bar_text = tak_dxf_tool_trihedral.tooltip = langconv("Import ThreeView DXF")

		tak_dxf_tool_face_twoedges = UI::Command.new(langconv("Create Faces from Two Edges.")) {
			face_from_twolines
		}
		tak_dxf_tool_face_twoedges.large_icon = tak_dxf_tool_face_twoedges.small_icon = icon_tak_faceedges
		tak_dxf_tool_face_twoedges.status_bar_text = tak_dxf_tool_face_twoedges.tooltip = langconv("Create Faces from Two Edges.")
		
		tak_dxf_tool_face_nonplaner = UI::Command.new(langconv("Create face from NonPlaner Edges.")) {
			create_face_from_nonplaner_edges
		}
		tak_dxf_tool_face_nonplaner.large_icon = tak_dxf_tool_face_nonplaner.small_icon = icon_tak_nonplaner
		tak_dxf_tool_face_nonplaner.status_bar_text = tak_dxf_tool_face_nonplaner.tooltip = langconv("Create face from NonPlaner Edges.")

		tak_dxf_tb = UI::Toolbar.new("TAK_DXF_IMPORT")
		tak_dxf_tb.add_item tak_dxf_tool_trihedral
		tak_dxf_tb.add_item tak_dxf_tool_face_twoedges
		tak_dxf_tb.add_item tak_dxf_tool_face_nonplaner
		tak_dxf_tb.show if tak_dxf_tb.get_last_state != 0
	end
end #class

tak2dxftimp = DxfTextImport.new
tak2dxftimp.add_dxftextiimport_menus()

end#module
